<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Expression Trees</TITLE>
<link href="suif1_32.html" rel=Next>
<link href="suif1_30.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_30.html">previous</A>, <A HREF="suif1_32.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC31" HREF="suif1_toc.html#TOC31">Expression Trees</A></H2>
<P>
<A NAME="IDX177"></A>

</P>
<P>
SUIF supports both expression trees and flat lists of instructions.
Procedures are always written out as flat lists.  After a procedure body
has been read from an input file, it can be converted to expression tree
form.  The <CODE>read_proc</CODE> method for the procedure symbol has a flag
that allows you to specify this; by default it builds the expression
trees.  You may also do the conversion manually as described below.
When the procedure body is written out, it is automatically converted
back to the flat list form.

</P>
<P>
In the flat list form, each SUIF instruction has its own
<CODE>tree_instr</CODE> node.  With expression trees, the only change is that
all of the instructions within an expression are grouped under the same
<CODE>tree_instr</CODE> node.  The instruction pointers in the operand fields
do not change.

</P>
<P>
Up to now we have implied that high-SUIF uses expression trees and that
low-SUIF uses the flat list representation, but the decision to use
expression trees is actually independent from the structure of the ASTs.
SUIF allows expressions trees to be used even if all of the high-level
control structures have been removed, and conversely the flat list
representation works with all kinds of AST nodes (although accessing the
<CODE>tree_for</CODE> operands is a little awkward).  In fact, the two
representations can even be mixed in the same procedure!

</P>
<P>
Some caution is needed here.  These two representations are not
equivalent.  An expression tree only specifies a partial order for the
evaluation of the instructions in the tree, whereas a flat list is a
total ordering.  Similarly, while flat lists allow you to intermix the
instructions from different expressions, with expression trees each
expression must be completely evaluated before proceeding to execute the
instructions for the next expression.  Thus, flat lists give you precise
control of the execution order for the instructions.  Because of this,
if you reorder the instructions in a flat list and then try to convert
to expression trees, the library may complain and promote temporaries to
variables in order to maintain the equivalent semantics.

</P>
<P>
<A NAME="IDX178"></A>
Methods are provided in the <CODE>tree_node_list</CODE> class to convert back
and forth between expression trees and flat lists.  The <CODE>flatten</CODE>
method converts all of the expression trees in the list and its child
lists to flat lists of instructions.  This is simply a matter of
creating new <CODE>tree_instr</CODE> nodes to hold the subexpressions and
inserting them into the lists.

</P>
<P>
<A NAME="IDX179"></A>
The <CODE>cvt_to_trees</CODE> method converts a tree node list to expression
tree form.  This does not actually change the instructions, but rather
collects the instructions within an expression under a single
<CODE>tree_instr</CODE> node.  Only contiguous instructions can be converted
into an expression tree.  If other instructions from outside the
expression are intermixed, building the expression tree may change the
behavior of the code.  Thus, if this occurs, the library will print a
warning message and split up the expression tree so that the original
semantics are preserved.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_30.html">previous</A>, <A HREF="suif1_32.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
